<?php 
    /*Feito por Victor Rangel
    Produto Odhen*/
namespace Teknisa\MAN\Controllers;
    
use Zeedhi\Framework\Controller\CrudWithParameterBag;
use Zeedhi\Framework\DataSource\DataSet;
use Zeedhi\Framework\DataSource\Manager;
use Zeedhi\Framework\DataSource\ParameterBag;
use Zeedhi\Framework\DTO; 
use Teknisa\MAN\Services;
use Teknisa\MAN\Utilities;
use Zeedhi\Framework\DTO\Response\Message;

class MovimentoCaixa extends \Teknisa\MAN\Controllers\TeknisaCrud { 
    
    protected $util;
    protected $row;
    
    //Parametros vindos do front
    private $NRORG;
    private $CDFILIAL;
    private $CDLOJA;
    private $DATA;
    private $DIA;
    private $MES;
    private $ANO;
    
    //variaveis definidas com respostas do BD 
    private $CDCONTADOR;
    private $CDEMPRESATG;
    private $CDCAIXA;
    
    //variaveis definidas ao longo da execucao private $stSeqVA;
    private $doCampoSomatorio_MR;
    private $stCampoSomatorio_MR;
    private $filtroCdsMovVenda;
    private $stSeqOU;
    private $doCampoSomatorio_DC;
    private $stCampoSomatorio_DC;
    private $stCampo09_DC;
    private $stCampo09;
    private $resultado;
    private $inSomaCaixa;
    private $stListaCaixaAux;
    private $inSomatorioDN;
    private $stTotalNotaDC;
    private $stCampo09_MR;
    
    //cds's
    private $cdsMovVenda;
    private $cdsMovCaixaAux;
    private $cdsCaixaControle;
    private $cdsCaixas;
    private $cdsSomatoria;
    private $cdsDN;
    private $cdsPesqRE;
    private $cdsPesqDtMes;
    private $cdsExportacaoTG;
    private $cdsPesqFilial;
    private $cdsTotalVenda;
    private $cdsTotalSangria;
    private $cdsECF;
    private $cdsReducaoz;
    private $cdsTotalVendaVA;
    private $cdsMovCaixa;
    private $cdsContraValeDC;
    private $cdsPARAvend;
    private $cdsARQUIVO;
    
    //Conteúdo do arquivo
    private $arquivo;
    
    //auxiliares
    private $auxCDLOJA;
    private $contador = 0;
    
    public function __construct (Manager $dataSourceManager, Utilities\Util $util, Services\MovimentoCaixa $movimentoCaixaService){
        $this->util = $util;
        $this->movimentoCaixaService = $movimentoCaixaService;
    }
    
    public function validacoes(DTO\Request\Row $request, DTO\Response $response) {
        $row = $request->getRow();
        $podeGerar = array(true);
        
        $params = array(
            ':CDFILIAL' => $row['CDFILIAL'],
            ':DATA'     => $row['DATA']
        );
        
        $cdsVdTurCaixa = $this->movimentoCaixaService->adqVdTurCaixa($params);
        
        if(!empty($cdsVdTurCaixa)) {
            $response->addMessage(new Message("Existe um caixa aberto nessa data!"));
            $podeGerar[0] = false;
        } else {
            $cdsNotas = $this->movimentoCaixaService->adqNotas($params);
            
            if(!empty($cdsNotas)) {
                $response->addMessage(new Message("Existem notas irregulares nessa data!"));
                $podeGerar[0] = false;
            }
        }
        
        $response->addDataSet(new DataSet('podeGerar', $podeGerar));
    }
    
    public function geraRelatorio(DTO\Request\Row $request, DTO\Response $response) {
        $row = $request->getRow();
        
        $this->NRORG = $row['NRORG'];
        $this->CDFILIAL = $row['CDFILIAL'];
        $this->CDLOJA = implode('_', $row['CDLOJA']);
        $this->DATA = $row['DATA'];
        $auxData = explode('-', $this->DATA);
        $this->DIA = $auxData[2];
        $this->MES = $auxData[1];
        $this->ANO = $auxData[0];
        $auxData = array_reverse($auxData);
        $this->DATA = implode('-', $auxData);
        unset($auxData);
        
        $this->cdsPesqFilial    = $this->adqPesqFilial();
        $this->cdsPesqRE        = $this->adqPesqRE();
        $this->cdsPesqDtMes     = $this->adqPesqDtMes();
        $this->cdsMovVenda      = $this->adqMovVenda();
        $this->cdsExportacaoTG  = $this->adqExportacaoTG();
        
        if(isset($this->cdsExportacaoTG[0])) {
            $this->CDEMPRESATG = $this->cdsExportacaoTG[0]['CDEMPRESATG'];
        } else {
            $this->CDEMPRESATG = $this->cdsExportacaoTG['CDEMPRESATG'];
        }
        
        $this->acmDelEXPORTACAOTG();
        
        if(isset($this->cdsMovVenda[0])) {
            $this->auxCDLOJA = $this->cdsMovVenda[0]['CDLOJA'];
        } else {
            $this->auxCDLOJA = $this->cdsMovVenda['CDLOJA'];
        }
        
        if(!empty($this->cdsMovVenda[0])) {
            $this->geraNumeracaoRe($this->cdsMovVenda[0]['CDLOJA']);
        }
        
        if(isset($this->cdsMovVenda[0])) {
            $this->CDLOJA = $this->cdsMovVenda[0]['CDLOJA'];
            $this->CDCAIXA = $this->cdsMovVenda[0]['CDCAIXA'];
        } else {
            $this->CDLOJA = $this->cdsMovVenda['CDLOJA'];
            $this->CDCAIXA = $this->cdsMovVenda['CDCAIXA'];
        }
        
        $this->calculaSomatoria();
        $this->GravaDN($this->stSeqOU);
        
        /* O primeiro registro é igual a "VA" e não trouxe nenhuma linha referente a movimentação do caixa controle*/
        if((isset($this->cdsMovVenda[0]) && $this->cdsMovVenda[0]['DOC'] == 'VA') || $this->cdsMovVenda['DOC'] == 'VA') {
            $this->GravaDiferenca();
        }
        
        if(isset($this->cdsMovVenda[0])) {
            for($this->contador = 0; $this->contador < count($this->cdsMovVenda); $this->contador++) {
                if($this->CDLOJA != $this->cdsMovVenda[$this->contador]['CDLOJA']) {
                    
                    $this->geraNumeracaoRe($this->cdsMovVenda[$this->contador]['CDLOJA']);
                    
                    $this->calculaSomatoria();
                    $this->GravaDN($this->stSeqOU);
                    
                    //BA Mudou de Loja e não trouxe nenhuma linha referente a movimentação do caixa controle
                    $stTotalNotaDC = '';
                    if((isset($this->cdsMovVenda[0]) && $this->cdsMovVenda[0]['DOC'] == 'VA') || $this->cdsMovVenda['DOC'] == 'VA') {
                        $this->GravaDiferenca();
                    }
                }
                
                //busca o ECF do caixa - número do PDV
                $this->cdsECF = $this->adqECF();
                
                if(empty($this->cdsECF) || $this->cdsECF === null) {
                    $stECF = '000';
                } else {
                    $stECF = str_pad(substr($this->cdsECF['NRECFTURCAIX'], count($this->cdsECF['NRECFTURCAIX'])-3, 3),3, '0', STR_PAD_LEFT);
                }
                
                if($this->cdsMovVenda[$this->contador]['DOC'] == 'VA') {
                    $stTipoRece = str_pad(substr($this->cdsMovVenda[$this->contador]['CDPRODINTE'], count($this->cdsMovVenda[$this->contador]['CDPRODINTE'])-10, 10), 10, '0', STR_PAD_LEFT);
                    $stTipo = $this->cdsMovVenda[$this->contador]['DOC'];
                    $this->cdsReducaoZ = $this->adqReducaoZ();
                    $this->cdsTotalVendaVA = $this->adqTotalVendaVA();
                    
                    $stTotalNota = $this->cdsTotalVendaVA['VRTOTVEND'];
                    $stTotalNota = explode('.', $stTotalNota);
                    $stTotalNota[1] = str_pad($stTotalNota[1], 4,'0', STR_PAD_RIGHT);
                    $stTotalNota[0] = str_pad($stTotalNota[0], 9,'0', STR_PAD_LEFT);
                    $stTotalNota = $stTotalNota[0].$stTotalNota[1];
                    
                    if(empty($this->cdsReducaoZ['NRPRIMCFREDZ']) || $this->cdsReducaoZ['NRPRIMCFREDZ'] === null) {
                        $stCupomInicial = '0000000000';
                    } else {
                        $stCupomInicial = str_pad($this->cdsReducaoZ['NRPRIMCFREDZ'], 10,'0', STR_PAD_LEFT);
                    }
                    
                    if(empty($this->cdsReducaoZ['NRULTCFREDZ']) || $this->cdsReducaoZ['NRULTCFREDZ'] === null) {
                        $stCupomFinal = '0000000000';
                    } else {
                        $stCupomFinal = str_pad($this->cdsReducaoZ['NRULTCFREDZ'], 10,'0', STR_PAD_LEFT);
                    }
                    
                    $stGrandeTotIni = $this->cdsReducaoZ['VRGTINIREDZ'];
                    if(strpos($stGrandeTotIni, '.')) {
                        $stGrandeTotIni = explode('.', $stGrandeTotIni);
                        $stGrandeTotIni[1] = str_pad($stGrandeTotIni[1], 2,'0', STR_PAD_RIGHT);
                        $stGrandeTotIni[0] = str_pad($stGrandeTotIni[0], 10,'0', STR_PAD_LEFT);
                        $stGrandeTotIni = $stGrandeTotIni[0].$stGrandeTotIni[1];
                    } else {
                        $stGrandeTotIni = str_pad($stGrandeTotIni, 12,'0', STR_PAD_LEFT);
                    }
                    
                    $stGrandeTotFin = $this->cdsReducaoZ['VRGTREDZ'];
                    if(strpos($stGrandeTotFin, '.')) {
                        $stGrandeTotFin = explode('.', $stGrandeTotFin);
                        $stGrandeTotFin[1] = str_pad($stGrandeTotFin[1], 2,'0', STR_PAD_RIGHT);
                        $stGrandeTotFin[0] = str_pad($stGrandeTotFin[0], 10,'0', STR_PAD_LEFT);
                        $stGrandeTotFin = $stGrandeTotFin[0].$stGrandeTotFin[1];
                    } else {
                        $stGrandeTotFin = str_pad($stGrandeTotFin, 12,'0', STR_PAD_LEFT);
                    }
                    
                    $stCancelamento = $this->cdsReducaoZ['VRTOTCANREDZ'];
                    if(strpos($stCancelamento, '.')) {
                        $stCancelamento = explode('.', $stCancelamento);
                        $stCancelamento[1] = str_pad($stCancelamento[1], 2,'0', STR_PAD_RIGHT);
                        $stCancelamento[0] = str_pad($stCancelamento[0], 8,'0', STR_PAD_LEFT);
                        $stCancelamento = $stCancelamento[0].$stCancelamento[1];
                    } else {
                        $stCancelamento = str_pad($stCancelamento, 10,'0', STR_PAD_LEFT);
                    }
                    
                    $stQuantidade = $this->cdsMovVenda[$this->contador]['VRABSOLUTO'];
                    if(strpos($stQuantidade, '.')) {
                        $stQuantidade = explode('.', $stQuantidade);
                        $stQuantidade[1] = str_pad($stQuantidade[1], 4,'0', STR_PAD_RIGHT);
                        $stQuantidade[0] = str_pad($stQuantidade[0], 6,'0', STR_PAD_LEFT);
                        $stQuantidade = $stQuantidade[0].$stQuantidade[1];
                    } else {
                        $stQuantidade = str_pad($stQuantidade, 10,'0', STR_PAD_LEFT);
                    }
                    
                    // Se stquantidade/valor venda liquida for 0,00 deve ser 1,00. Neste caso \E9 da redu\E7\E3o z.
                    if($stQuantidade == '0000000000') {
                        $stQuantidade = '0000010000';
                    }
                    
                    $stDesconto = $this->cdsMovVenda[$this->contador]['VRDESCONTO'];
                    if(strpos($stDesconto, '.')) {
                        $stDesconto = explode('.', $stDesconto);
                        $stDesconto[1] = str_pad($stDesconto[1], 4,'0', STR_PAD_RIGHT);
                        $stDesconto[0] = str_pad($stDesconto[0], 9,'0', STR_PAD_LEFT);
                        $stDesconto = $stDesconto[0].$stDesconto[1];
                    } else {
                        $stDesconto = str_pad($stDesconto, 13,'0', STR_PAD_LEFT);
                    }
                    
                    if(empty($this->cdsReducaoZ['NRREDREDZ']) || $this->cdsReducaoZ['NRREDREDZ'] === null) {
                        $stReducao = '0000';
                    } else {
                        $stReducao = str_pad(substr($this->cdsReducaoZ['NRREDREDZ'], count($this->cdsReducaoZ['NRREDREDZ']) -4, 4), 4,'0', STR_PAD_LEFT);
                    }
                    
                    if(empty($this->cdsReducaoZ['NRREINIREDZ']) || $this->cdsReducaoZ['NRREINIREDZ'] === null) {
                        $stReinicio = '00000';
                    } else {
                        $stReinicio = str_pad(substr($this->cdsReducaoZ['NRREINIREDZ'], count($this->cdsReducaoZ['NRREINIREDZ']) -5, 5), 5,'0', STR_PAD_LEFT);
                    }
                    
                    $stSerieModelo = 'MR99';
                    $stCampo09 = str_pad(substr($stCupomInicial, 5, 6), 6, '0', STR_PAD_LEFT);
                    $this->stCampo09_MR = str_pad(($this->stCampo09_MR + 1), 6,'0', STR_PAD_LEFT);
                    $stCampo14 = $this->stCampoSomatorio_MR;
                } else {
                    $stTipoRece = str_pad($this->cdsMovVenda[$this->contador]['CDPRODINTE'], 10,'0', STR_PAD_LEFT);
                    $stTipo = $this->cdsMovVenda[$this->contador]['DOC'];
                    $this->cdsMovCaixa = $this->adqMovCaixa();
                    
                    if($this->cdsMovVenda[$this->contador]['DOC'] == 'DC') {
                        $this->cdsContraValeDC = $this->adqContraValeDC();
                        $this->cdsTotalVenda = $this->adqTotalVenda();
                        $this->cdsTotalSangria = $this->adqTotalSangria();
                        
                        $stTotalNota = $this->cdsMovVenda[$this->contador]['VRVALOR'];
                        if(strpos($stTotalNota, '.')) {
                            $stTotalNota = explode('.', $stTotalNota);
                            $stTotalNota[1] = str_pad($stTotalNota[1], 4,'0', STR_PAD_RIGHT);
                            $stTotalNota[0] = str_pad($stTotalNota[0], 9,'0', STR_PAD_LEFT);
                            $stTotalNota = $stTotalNota = $stTotalNota[0].'.'.$stTotalNota[1];
                        } else {
                            $stTotalNota = str_pad($stTotalNota, 12,'0', STR_PAD_LEFT);
                        }
                        
                        $stTotalNotaDC = $stTotalNota;                  
                    } else {
                        $stTotalNota = $this->cdsMovVenda[$this->contador]['VRMOVIVEND'];
                        if(strpos($stTotalNota, '.')) {
                            $stTotalNota = explode('.', $stTotalNota);
                            $stTotalNota[1] = str_pad($stTotalNota[1], 4,'0', STR_PAD_RIGHT);
                            $stTotalNota[0] = str_pad($stTotalNota[0], 9,'0', STR_PAD_LEFT);
                            $stTotalNota = $stTotalNota = $stTotalNota[0].'.'.$stTotalNota[1];
                        } else {
                            $stTotalNota = str_pad($stTotalNota, 12,'0', STR_PAD_LEFT);
                        }
                    }
                    
                    $stTotalNota = str_replace('.','', $stTotalNota);
                    
                    $stCupomInicial = '0000000000';
                    $stCupomFinal   = '0000000000';
                    $stGrandeTotIni = '000000000000';
                    $stGrandeTotFin = '000000000000';
                    $stQuantidade   = '0000010000';
                    $stDesconto     = '0000000000000';
                    $stCancelamento = '0000000000';
                    $stReducao      = '0000';
                    $stReinicio     = '00000';
                    $stSerieModelo  = 'DC99';
                    $stCampo09      = str_pad($stCampo09_DC, 6, '0', STR_PAD_LEFT);
                    $stCampo09_DC   = str_pad(($stCampo09_DC + 1), 6, '0', STR_PAD_LEFT);
                    $stCampo14      = $stCampoSomatorio_DC;
                }
                
                $stValor = abs($this->cdsDN['VRVALOR']);
                $stValor = explode('.', $stValor);
                $stValor[1] = str_pad($stValor[1], 4,'0', STR_PAD_RIGHT);
                $stValor[0] = str_pad($stValor[0], 9,'0', STR_PAD_LEFT);
                $stValor = $stValor[0].$stValor[1];
                
                if($this->cdsMovVenda[$this->contador]['IDIMPTPRECETC'] == 'S') {
                    
                    if($stTipo == 'VA') {
                        $stSeqAux = substr((7000 + $this->stSeqVA), 0, 4);
                    } else {
                        $stSeqAux = substr((7500 + $this->stSeqOU), 0, 4);
                    }
                    
                    $stLinha = '';
                    
                    /*{1}*/$stLinha[] = $this->CDEMPRESATG;
                    /*{2}*/$stLinha[] = str_pad(substr($this->cdsMovVenda[$this->contador]['CDLOJA'], count($this->cdsMovVenda[$this->contador]['CDLOJA'])-4, 4), 4, '0', STR_PAD_LEFT);
                    /*{3}*/$stLinha[] = $stSeqAux;
                    
                    /*{4}*/$cdsData = $this->cdsMovVenda[$this->contador]['DTMOVIMCAIXA'];
                    /*{4}*/$cdsData = substr($cdsData, 0, 10);
                    /*{4}*/$cdsData = explode('/', $cdsData);
                    /*{4}*/$cdsData = array_reverse($cdsData);
                    /*{4}*/$cdsData = $cdsData[0].$cdsData[1].$cdsData[2];
                    /*{4}*/$stLinha[] = $cdsData;
                    
                    /*{5}*/if($stTipo == 'VA') {
                    /*{5}*/    $stLinha[] = $this->stCampo05;
                    /*{5}*/} else {
                    /*{5}*/    $stLinha[] = substr($stCampoSomatorio_DC, 1, 10);
                    /*{5}*/}
                    
                    /*{6}*/$stLinha[] = $stTipo;
                    /*{7}*/$stLinha[] = 'J';
                    
                    /*{8}*/if((($this->cdsMovVenda[$this->contador]['IDTIPORECE'] == '1') || ($this->cdsMovVenda[$this->contador]['IDTIPORECE'] == '2') || ($this->cdsMovVenda[$this->contador]['IDTIPORECE'] == '3'))) {
                    /*{8}*/    if(empty($this->cdsMovVenda[$this->contador]['CDADMINCART']) || $this->cdsMovVenda[$this->contador]['CDADMINCART'] === null) {
                    /*{8}*/        $stLinha[] = '00000000000000';
                    /*{8}*/    } else {
                    /*{8}*/        $stLinha[] = str_pad(substr($this->cdsMovVenda[$this->contador]['CDADMINCART'], count($this->cdsMovVenda[$this->contador]['CDADMINCART'])-14, 14), 14,'0', STR_PAD_LEFT);
                    /*{8}*/    }
                    /*{8}*/} else {
                    /*{8}*/    $stLinha[] = str_pad(substr($this->cdsPesqFilial['NRINSJURFILI'], count($this->cdsPesqFilial['NRINSJURFILI']) -14, 14), 14,'0', STR_PAD_LEFT);
                    /*{8}*/}
                    
                    /*{9}*/$stLinha[] = $stCampo09;
                    /*{10}*/$stLinha[] = $stSerieModelo;
                    /*{11}*/$stLinha[] = $cdsData;
                    /*{12}*/$stLinha[] = $cdsData;
                    unset($cdsData);
                    /*{13}*/$stLinha[] = substr(str_pad($this->cdsMovVenda[$this->contador]['CDLOJA'], 4, '0', STR_PAD_LEFT), 0, 4);
                    /*{14}*/$stLinha[] = '00000000000';
                    /*{15}*/$stLinha[] = '00000000000';
                    /*{16}*/$stLinha[] = '00000000000';
                    /*{17}*/$stLinha[] = '00000000000';
                    /*{18}*/$stLinha[] = $stCupomInicial;
                    /*{19}*/$stLinha[] = $stCupomFinal;
                    /*{20}*/$stLinha[] = $stGrandeTotFin;
                    /*{21}*/$stLinha[] = $stTipoRece;
                    /*{22}*/$stLinha[] = $stQuantidade;
                    /*{23}*/$stLinha[] = $stValor;
                    /*{24}*/$stLinha[] = $stDesconto;
                    /*{25}*/$stLinha[] = '0000000000000';
                    /*{26}*/$stLinha[] = $stTotalNota;
                    /*{27}*/$stLinha[] = '    ';
                    /*{28}*/$stLinha[] = '0';
                    /*{29}*/$stLinha[] = '0000000';
                    /*{30}*/$stLinha[] = '000000';
                    /*{31}*/$stLinha[] = '00000000000000';
                    /*{32}*/$stLinha[] = '0000';
                    /*{33}*/$stLinha[] = '00000000000000000000';
                    /*{34}*/$stLinha[] = '00000000000';
                    /*{35}*/$stLinha[] = '00000000000';
                    /*{36}*/$stLinha[] = '00000000000';
                    /*{37}*/$stLinha[] = $stECF;
                    /*{38}*/$stLinha[] = $stReducao;
                    /*{39}*/$stLinha[] = $stGrandeTotIni;
                    /*{40}*/$stLinha[] = $stCancelamento;
                    /*{41}*/$stLinha[] = $stReinicio;
                
                    $this->cdsARQUIVO[] = $stLinha;
                    $this->arquivo[] = implode('', $stLinha);
                    
                    $CDLOJA = $this->cdsMovVenda[$this->contador]['CDLOJA'];
                    $CDCAIXA = $this->cdsMovVenda[$this->contador]['CDCAIXA'];
                    
                    $this->contador++;
                    
                    //Mudou de caixa e trouxe movimenta\E7\E3o referente ao caixa controle
                    if($this->contador < count($this->cdsMovVenda)) {
                        if(($CDCAIXA != $this->cdsMovVenda[$this->contador]['CDCAIXA']) && ($this->cdsMovVenda[$this->contador]['DOC'] == 'VA') && ($stTipo != 'VA')) {
                            $this->GravaDiferenca();
                        }
                    }
                    
                    $this->contador--;
                }
            }
        } else {
            if($this->CDLOJA != $this->cdsMovVenda['CDLOJA']) {
                   
                   $this->geraNumeracaoRe($this->cdsMovVenda['CDLOJA']);
                   
                   $this->calculaSomatoria();
                   $this->GravaDN($this->stSeqOU);
                   
                   //BA Mudou de Loja e não trouxe nenhuma linha referente a movimentação do caixa controle
                   $stTotalNotaDC = '';
                   if((isset($this->cdsMovVenda[0]) && $this->cdsMovVenda[0]['DOC'] == 'VA') || $this->cdsMovVenda['DOC'] == 'VA') {
                       $this->GravaDiferenca();
                   }
               }
               
               //busca o ECF do caixa - número do PDV
               $this->cdsECF = $this->adqECF();
               
               if(empty($this->cdsECF) || $this->cdsECF === null) {
                   $stECF = '000';
               } else {
                   $stECF = str_pad(substr($this->cdsECF['NRECFTURCAIX'], count($this->cdsECF['NRECFTURCAIX'])-3, 3), 3, '0', STR_PAD_LEFT);
               }
               
               if($this->cdsMovVenda['DOC'] == 'VA') {
                   $stTipoRece = str_pad(substr($this->cdsMovVenda['CDPRODINTE'], count($this->cdsMovVenda['CDPRODINTE'])-10, 10), 10, '0', STR_PAD_LEFT);
                   $stTipo = $this->cdsMovVenda['DOC'];
                   $this->cdsReducaoZ = $this->adqReducaoZ();
                   $this->cdsTotalVendaVA = $this->adqTotalVendaVA();
                   
                   $stTotalNota = $this->cdsTotalVendaVA['VRTOTVEND'];
                   $stTotalNota = explode('.', $stTotalNota);
                   $stTotalNota[1] = str_pad($stTotalNota[1], 4,'0', STR_PAD_RIGHT);
                   $stTotalNota[0] = str_pad($stTotalNota[0], 9,'0', STR_PAD_LEFT);
                   $stTotalNota = $stTotalNota[0].$stTotalNota[1];
                   
                   if(empty($this->cdsReducaoZ['NRPRIMCFREDZ']) || $this->cdsReducaoZ['NRPRIMCFREDZ'] === null) {
                       $stCupomInicial = '0000000000';
                   } else {
                       $stCupomInicial = str_pad($this->cdsReducaoZ['NRPRIMCFREDZ'], 10,'0', STR_PAD_LEFT);
                   }
                   
                   if(empty($this->cdsReducaoZ['NRULTCFREDZ']) || $this->cdsReducaoZ['NRULTCFREDZ'] === null) {
                       $stCupomFinal = '0000000000';
                   } else {
                       $stCupomFinal = str_pad($this->cdsReducaoZ['NRULTCFREDZ'], 10,'0', STR_PAD_LEFT);
                   }
                   
                   $stGrandeTotIni = $this->cdsReducaoZ['VRGTINIREDZ'];
                   $stGrandeTotIni = explode('.', $stGrandeTotIni);
                   $stGrandeTotIni[1] = str_pad($stGrandeTotIni[1], 2,'0', STR_PAD_RIGHT);
                   $stGrandeTotIni[0] = str_pad($stGrandeTotIni[0], 10,'0', STR_PAD_LEFT);
                   $stGrandeTotIni = $stGrandeTotIni[0].$stGrandeTotIni[1];
                   
                   $stGrandeTotFin = $this->cdsReducaoZ['VRGTREDZ'];
                   $stGrandeTotFin = explode('.', $stGrandeTotFin);
                   $stGrandeTotFin[1] = str_pad($stGrandeTotFin[1], 2,'0', STR_PAD_RIGHT);
                   $stGrandeTotFin[0] = str_pad($stGrandeTotFin[0], 10,'0', STR_PAD_LEFT);
                   $stGrandeTotFin = $stGrandeTotFin[0].$stGrandeTotFin[1];
                   
                   $stCancelamento = $this->cdsReducaoZ['VRTOTCANREDZ'];
                   $stCancelamento = explode('.', $stCancelamento);
                   $stCancelamento[1] = str_pad($stCancelamento[1], 2,'0', STR_PAD_RIGHT);
                   $stCancelamento[0] = str_pad($stCancelamento[0], 8,'0', STR_PAD_LEFT);
                   $stCancelamento = $stCancelamento[0].$stCancelamento[1];
                   
                   $stQuantidade = $this->cdsMovVenda['VRABSOLUTO'];
                   $stQuantidade = explode('.', $stQuantidade);
                   $stQuantidade[1] = str_pad($stQuantidade[1], 4,'0', STR_PAD_RIGHT);
                   $stQuantidade[0] = str_pad($stQuantidade[0], 6,'0', STR_PAD_LEFT);
                   $stQuantidade = $stQuantidade[0].$stQuantidade[1];
                   
                   // Se stquantidade/valor venda liquida for 0,00 deve ser 1,00. Neste caso \E9 da redu\E7\E3o z.
                   if($stQuantidade == '0000000000') {
                       $stQuantidade = '0000010000';
                   }
                   
                   $stDesconto = $this->cdsMovVenda['VRDESCONTO'];
                   $stDesconto = explode('.', $stDesconto);
                   $stDesconto[1] = str_pad($stDesconto[1], 4,'0', STR_PAD_RIGHT);
                   $stDesconto[0] = str_pad($stDesconto[0], 9,'0', STR_PAD_LEFT);
                   $stDesconto = $stDesconto[0].$stDesconto[1];
                   
                   if(empty($this->cdsReducaoZ['NRREDREDZ']) || $this->cdsReducaoZ['NRREDREDZ'] === null) {
                       $stReducao = '0000';
                   } else {
                       $stReducao = str_pad(substr($this->cdsReducaoZ['NRREDREDZ'], count($this->cdsReducaoZ['NRREDREDZ']) -4, 4), 4,'0', STR_PAD_LEFT);
                   }
                   
                   if(empty($this->cdsReducaoZ['NRREINIREDZ']) || $this->cdsReducaoZ['NRREINIREDZ'] === null) {
                       $stReinicio = '00000';
                   } else {
                       $stReinicio = str_pad(substr($this->cdsReducaoZ['NRREINIREDZ'], count($this->cdsReducaoZ['NRREINIREDZ']) -5, 5), 5,'0', STR_PAD_LEFT);
                   }
                   
                   $stSerieModelo = 'MR99';
                   $stCampo09 = str_pad(substr($stCupomInicial, 5, 6), 6, '0', STR_PAD_LEFT);
                   $this->stCampo09_MR = str_pad(($this->stCampo09_MR + 1), 6,'0', STR_PAD_LEFT);
                   $stCampo14 = $this->stCampoSomatorio_MR;
               } else {
                   $stTipoRece = str_pad($this->cdsMovVenda['CDPRODINTE'], 10,'0', STR_PAD_LEFT);
                   $stTipo = $this->cdsMovVenda['DOC'];
                   $this->cdsMovCaixa = $this->adqMovCaixa();
                   
                   if($this->cdsMovVenda['DOC'] == 'DC') {
                       $this->cdsContraValeDC = $this->adqContraValeDC();
                       $this->cdsTotalVenda = $this->adqTotalVenda();
                       $this->cdsTotalSangria = $this->adqTotalSangria();
                       
                       $stTotalNota = $this->cdsMovVenda['VRVALOR'];
                       $stTotalNota = explode('.', $stTotalNota);
                       $stTotalNota[1] = str_pad($stTotalNota[1], 4,'0', STR_PAD_RIGHT);
                       $stTotalNota[0] = str_pad($stTotalNota[0], 9,'0', STR_PAD_LEFT);
                       $stTotalNota = $stTotalNota = $stTotalNota[0].'.'.$stTotalNota[1];
                       
                       $stTotalNotaDC = $stTotalNota;                   
                   } else {
                       $stTotalNota = $this->cdsMovVenda['VRMOVIVEND'];
                       $stTotalNota = explode('.', $stTotalNota);
                       $stTotalNota[1] = str_pad($stTotalNota[1], 4,'0', STR_PAD_RIGHT);
                       $stTotalNota[0] = str_pad($stTotalNota[0], 9,'0', STR_PAD_LEFT);
                       $stTotalNota = $stTotalNota = $stTotalNota[0].'.'.$stTotalNota[1];
                   }
                   
                   $stTotalNota = str_replace('.','', $stTotalNota);
                   
                   $stCupomInicial = '0000000000';
                   $stCupomFinal   = '0000000000';
                   $stGrandeTotIni = '000000000000';
                   $stGrandeTotFin = '000000000000';
                   $stQuantidade   = '0000010000';
                   $stDesconto     = '0000000000000';
                   $stCancelamento = '0000000000';
                   $stReducao      = '0000';
                   $stReinicio     = '00000';
                   $stSerieModelo  = 'DC99';
                   $stCampo09      = str_pad($stCampo09_DC, 6, '0', STR_PAD_LEFT);
                   $stCampo09_DC   = str_pad(($stCampo09_DC + 1), 6,'0', STR_PAD_LEFT);
                   $stCampo14      = $stCampoSomatorio_DC;
               }
               
               $stValor = abs($this->cdsDN['VRVALOR']);
               $stValor = explode('.', $stValor);
               $stValor[1] = str_pad($stValor[1], 4,'0', STR_PAD_RIGHT);
               $stValor[0] = str_pad($stValor[0], 9,'0', STR_PAD_LEFT);
               $stValor = $stValor[0].$stValor[1];
               
               if($this->cdsMovVenda['IDIMPTPRECETC'] == 'S') {
                   
                   if($stTipo == 'VA') {
                       $stSeqAux = substr((7000 + $this->stSeqVA), 0, 4);
                   } else {
                       $stSeqAux = substr((7500 + $this->stSeqOU), 0, 4);
                   }
                   
                   $stLinha = '';
                   
                   /*{1}*/$stLinha[] = $this->CDEMPRESATG;
                   /*{2}*/$stLinha[] = str_pad(substr($this->cdsMovVenda['CDLOJA'], count($this->cdsMovVenda['CDLOJA'])-4, 4), 4, '0', STR_PAD_LEFT);
                   /*{3}*/$stLinha[] = $stSeqAux;
                   
                   /*{4}*/$cdsData = $this->cdsMovVenda['DTMOVIMCAIXA'];
                   /*{4}*/$cdsData = substr($cdsData, 0, 10);
                   /*{4}*/$cdsData = explode('/', $cdsData);
                   /*{4}*/$cdsData = array_reverse($cdsData);
                   /*{4}*/$cdsData = $cdsData[0].$cdsData[1].$cdsData[2];
                   /*{4}*/$stLinha[] = $cdsData;
                   
                   /*{5}*/if($stTipo == 'VA') {
                   /*{5}*/    $stLinha[] = $this->stCampo05;
                   /*{5}*/} else {
                   /*{5}*/    $stLinha[] = substr($stCampoSomatorio_DC, 1, 10);
                   /*{5}*/}
                   
                   /*{6}*/$stLinha[] = $stTipo;
                   /*{7}*/$stLinha[] = 'J';
                   
                   /*{8}*/if((($this->cdsMovVenda['IDTIPORECE'] == '1') || ($this->cdsMovVenda['IDTIPORECE'] == '2') || ($this->cdsMovVenda['IDTIPORECE'] == '3'))) {
                   /*{8}*/    if(empty($this->cdsMovVenda['CDADMINCART']) || $this->cdsMovVenda['CDADMINCART'] === null) {
                   /*{8}*/        $stLinha[] = '00000000000000';
                   /*{8}*/    } else {
                   /*{8}*/        $stLinha[] = str_pad(substr($this->cdsMovVenda['CDADMINCART'], count($this->cdsMovVenda['CDADMINCART'])-14, 14), 14,'0', STR_PAD_LEFT);
                   /*{8}*/    }
                   /*{8}*/} else {
                   /*{8}*/    $stLinha[] = str_pad(substr($this->cdsPesqFilial['NRINSJURFILI'], count($this->cdsPesqFilial['NRINSJURFILI']) -14, 14), 14,'0', STR_PAD_LEFT);
                   /*{8}*/}
                   
                   /*{9}*/$stLinha[] = $stCampo09;
                   /*{10}*/$stLinha[] = $stSerieModelo;
                   /*{11}*/$stLinha[] = $cdsData;
                   /*{12}*/$stLinha[] = $cdsData;
                   unset($cdsData);
                   /*{13}*/$stLinha[] = substr(str_pad($this->cdsMovVenda['CDLOJA'], 4, '0', STR_PAD_LEFT), 0, 4);
                   /*{14}*/$stLinha[] = '00000000000';
                   /*{15}*/$stLinha[] = '00000000000';
                   /*{16}*/$stLinha[] = '00000000000';
                   /*{17}*/$stLinha[] = '00000000000';
                   /*{18}*/$stLinha[] = $stCupomInicial;
                   /*{19}*/$stLinha[] = $stCupomFinal;
                   /*{20}*/$stLinha[] = $stGrandeTotFin;
                   /*{21}*/$stLinha[] = $stTipoRece;
                   /*{22}*/$stLinha[] = $stQuantidade;
                   /*{23}*/$stLinha[] = $stValor;
                   /*{24}*/$stLinha[] = $stDesconto;
                   /*{25}*/$stLinha[] = '0000000000000';
                   /*{26}*/$stLinha[] = $stTotalNota;
                   /*{27}*/$stLinha[] = '    ';
                   /*{28}*/$stLinha[] = '0';
                   /*{29}*/$stLinha[] = '0000000';
                   /*{30}*/$stLinha[] = '000000';
                   /*{31}*/$stLinha[] = '00000000000000';
                   /*{32}*/$stLinha[] = '0000';
                   /*{33}*/$stLinha[] = '00000000000000000000';
                   /*{34}*/$stLinha[] = '00000000000';
                   /*{35}*/$stLinha[] = '00000000000';
                   /*{36}*/$stLinha[] = '00000000000';
                   /*{37}*/$stLinha[] = $stECF;
                   /*{38}*/$stLinha[] = $stReducao;
                   /*{39}*/$stLinha[] = $stGrandeTotIni;
                   /*{40}*/$stLinha[] = $stCancelamento;
                   /*{41}*/$stLinha[] = $stReinicio;
               
                   $this->cdsARQUIVO[] = $stLinha;
                   $this->arquivo[] = implode('', $stLinha);
              }
        }
        
        $this->acmUpdTurcaixa();
        $this->cdsPARAvend = $this->adqPARAvend();
        
        if($this->cdsPARAvend['IDGERACAOTC'] == '1' || $this->cdsPARAvend['IDGERACAOTC'] == '3') {
            $this->acmInsEXPORTACAOTG();
        }
        
        $response->addDataSet(new DataSet('TC', $this->arquivo));
    }
    
    //funções de manipulação
    private function prxNumeroRENovo($stChave, $stData, $inQtde) {
        $this->CDCONTADOR = 'NUMERORENOVO'.$stData.$stChave;
        $resultado = $this->adqVerificaRe();
        
        if(empty($resultado) || $resultado == null) {
            $resultado = $this->util->newCode($stChave, $inQtde);
            $this->NRSEQUENCIAL = str_pad($resultado, 4,'0', STR_PAD_LEFT);
            $this->acmInsereNovoCodigo();
        } else {
            $this->NRSEQUENCIAL = $this->adqVerificaRe()['NRSEQUENCIAL'];
        }
        
        return $this->NRSEQUENCIAL;
    }
    
    private function geraNumeracaoRe($CDLOJA) {
        
        // Filtra numero de registros VA -->> MR
        $this->auxCDLOJA = $CDLOJA;
        
        $this->filtroCdsMovVenda = array_filter($this->cdsMovVenda, function($elemento){
            $validate = false;
            
            if($elemento['DOC'] == 'VA' && $elemento['CDLOJA'] == $this->auxCDLOJA) {
                $validate = true;
            }
            
            return $validate;
        });
        
        $auxCDLOJA = substr($CDLOJA, -3);
        $stChave = $this->ANO.'VA'.$auxCDLOJA;
        $stData = $this->ANO.$this->MES.$this->DIA;
        $this->stSeqVA = $this->prxNumeroRENovo($stChave, $stData, 1);
        
        $this->doCampoSomatorio_MR = 0;
        $this->stCampo09_MR = '000001';
        $this->stCampoSomatorio_MR = 000001;
        
        
        if(count($this->cdsMovVenda) > 0) {
            for($i = 0; $i < count($this->cdsMovVenda); $i++) {
                $this->doCampoSomatorio_MR = $this->doCampoSomatorio_MR + $i + 1;
            }
            $this->doCampoSomatorio_MR = str_pad($this->doCampoSomatorio_MR, 11,'0', STR_PAD_LEFT);
        } else {
            $this->stCampoSomatorio_MR = str_pad('1', 11);
        }
        
        // Filtra numero de registros OU outros -->> DC
        $this->filtroCdsMovVenda = array_filter($this->cdsMovVenda, function($elemento){
            $validate = false;
            
            if($elemento['DOC'] != 'VA' && $elemento['CDLOJA'] == $this->auxCDLOJA) {
                $validate = true;
            }
            
            return $validate;
        });
        
        $stChave = $this->ANO.'OU'.$auxCDLOJA;
        $this->stSeqOU = $this->prxNumeroRENovo($stChave, $stData, 1);
        $this->doCampoSomatorio_DC = 0;
        $this->stCampo09_DC = 000001;
        
        if(count($this->cdsMovVenda) > 0) {
            for($i = 0; $i < count($this->cdsMovVenda); $i++) {
                $this->doCampoSomatorio_DC = $this->doCampoSomatorio_DC + $i + 1;
            }
            $this->stCampoSomatorio_DC = str_pad($this->doCampoSomatorio_DC, 11, '0', STR_PAD_LEFT);
        } else {
            $this->stCampoSomatorio_DC = str_pad('1', 11);
        }
    }
    
    private function calculaSomatoria() {
        $this->cdsSomatoria = $this->adqSomatoria();
        $this->cdsMovCaixaAux = $this->adqMovCaixaAux();
        
        $this->inSomaCaixa = 0;
        
        if(isset($this->cdsMovCaixaAux[0])) {
            if(isset($this->cdsMovVenda[0])) {
                for($i = 0; $i < count($this->cdsMovCaixaAux); $i++) {
                    $this->inSomaCaixa += $this->cdsMovCaixaAux[$i]['CDCAIXA'].substr($this->cdsMovVenda[$this->contador]['DTMOVIMCAIXA'], 0, -17);
                }
            } else{
                for($i = 0; $i < count($this->cdsMovCaixaAux); $i++) {
                    $this->inSomaCaixa += $this->cdsMovCaixaAux[$i]['CDCAIXA'].substr($this->cdsMovVenda['DTMOVIMCAIXA'], 0, -17);
                }
            }
        } else {
            if(isset($this->cdsMovVenda[0])) {
                $this->inSomaCaixa = $this->cdsMovCaixaAux['CDCAIXA'].substr($this->cdsMovVenda[$this->contador]['DTMOVIMCAIXA'], 0, -17);
            } else {
                $this->inSomaCaixa = $this->cdsMovCaixaAux['CDCAIXA'].substr($this->cdsMovVenda['DTMOVIMCAIXA'], 0, -17);
            }
        }
        
        $this->cdsCaixaControle = $this->adqCaixaControle($this->auxCDLOJA);
        
        if(isset($this->cdsCaixaControle[0])) {
            for($i = 0; $i < count($this->cdsCaixaControle); $i++) {
                $this->CDCAIXA .= $this->cdsCaixaControle[$i]['CDFILIAL'].$this->cdsCaixaControle[$i]['CDCAIXA'].'_';
            }
        } else {
            $this->CDCAIXA = $this->cdsCaixaControle['CDFILIAL'].$this->cdsCaixaControle['CDCAIXA'].'_';
        }
        
        $this->cdsCaixas = $this->adqCaixas();
        $this->stListaCaixaAux = '';
        $this->inSomatorioDN = 0;
        
        if(isset($this->cdsCaixas[0])) {
            for($i = 0; $i < count($this->cdsCaixas); $i++) {
                $this->stListaCaixaAux .= $this->cdsCaixas[$i]['CDFILIAL'].$this->cdsCaixas[$i]['CDCAIXA'].'_';
                $this->inSomatorioDN += $this->cdsCaixas[$i]['CDCAIXA'].$this->DIA;
            }
        } else {
            $this->stListaCaixaAux = $this->cdsCaixas['CDFILIAL'].$this->cdsCaixas['CDCAIXA'].'_';
            $this->inSomatorioDN = $this->cdsCaixas['CDCAIXA'].$this->DIA;
        }
            $this->stCampo05 = str_pad($this->cdsSomatoria['VRSOMA'], 10,'0', STR_PAD_LEFT);
    }
    
    private function GravaDN($stNrSeqRe) {
        
        //var
        //  stValor, stLinha, stSeqAux ;string;
        
        $this->cdsDN = $this->adqDN();
        
        if(!empty($this->cdsDN)) {
            $stValor = abs($this->cdsDN['VRVALOR']);
            $stValor = explode('.', $stValor);
            $stValor[1] = str_pad($stValor[1], 4,'0', STR_PAD_RIGHT);
            $stValor[0] = str_pad($stValor[0], 9,'0', STR_PAD_LEFT);
            $stValor = $stValor[0].$stValor[1];
            $stSeqAux = substr(7500 + $stNrSeqRe, 0, 4);
            
            $stLinha = '';
            
            /*{1}*/$stLinha[] = $this->CDEMPRESATG;
            
            /*{2}*/if(isset($this->cdsMovVenda[0])) {
            /*{2}*/    $stLinha[] = str_pad(substr($this->cdsMovVenda[$this->contador]['CDLOJA'], count($this->cdsMovVenda[$this->contador]['CDLOJA'])-4, 4), 4, '0', STR_PAD_LEFT);
            /*{2}*/} else {
            /*{2}*/    $stLinha[] = str_pad(substr($this->cdsMovVenda['CDLOJA'], count($this->cdsMovVenda['CDLOJA'])-4, 4), 4, '0', STR_PAD_LEFT);
            /*{2}*/}
            
            /*{3}*/$stLinha[] = $stSeqAux;
            
            /*{4}*/$cdsData = $this->cdsDN['DTENTRVENDA'];
            /*{4}*/$cdsData = substr($cdsData, 0, 10);
            /*{4}*/$cdsData = explode('/', $cdsData);
            /*{4}*/$cdsData = array_reverse($cdsData);
            /*{4}*/$stLinha[] = $cdsData[0].$cdsData[1].$cdsData[2];
            
            /*{5}*/$stLinha[] = str_pad($this->stCampo05, 6,'0', STR_PAD_LEFT);
            /*{6}*/$stLinha[] = 'DN';
            /*{7}*/$stLinha[] = 'J';
            /*{8}*/$stLinha[] = str_pad(substr($this->cdsPesqFilial['NRINSJURFILI'], count($this->cdsPesqFilial['NRINSJURFILI'])-14, 14), 14, '0', STR_PAD_LEFT);
            
            /*{9}*/if(empty($this->cdsDN['CDCAIXA'])) {
            /*{9}*/    $stLinha[] = '0000';
            /*{9}*/} else {
            /*{9}*/    $stLinha[] = str_pad($this->cdsDN['CDCAIXA'], 4, '0', STR_PAD_LEFT) . $cdsData[2];
            /*{9}*/}
            unset($cdsData);
     
            /*{10}*/$stLinha[] = 'DN99';
            
            /*{11}*/$cdsData = $this->cdsDN['DTENTRVENDA'];
            /*{11}*/$cdsData = substr($cdsData, 0, 10);
            /*{11}*/$cdsData = explode('/', $cdsData);
            /*{11}*/$cdsData = array_reverse($cdsData);
            /*{11}*/$cdsData = implode('', $cdsData);
            /*{11}*/$stLinha[] = $cdsData;
            
            /*{12}*/$stLinha[] = $cdsData;
            /*{13}*/$stLinha[] = substr(str_pad($this->cdsDN['CDLOJA'], 4, '0', STR_PAD_LEFT), 0, 4);
            /*{14}*/$stLinha[] = '00000000000';
            /*{15}*/$stLinha[] = '00000000000';
            /*{16}*/$stLinha[] = '00000000000';
            /*{17}*/$stLinha[] = '00000000000';
            /*{18}*/$stLinha[] = '0000000000';
            /*{19}*/$stLinha[] = '0000000000';
            /*{20}*/$stLinha[] = '000000000000';
            /*{21}*/$stLinha[] = '5599900201';
            /*{22}*/$stLinha[] = '0000010000';
            /*{23}*/$stLinha[] = $stValor;
            /*{24}*/$stLinha[] = '0000000000000';
            /*{25}*/$stLinha[] = '0000000000000';
            /*{26}*/$stLinha[] = $stValor;
            
            /*{27}*/if(isset($this->cdsMovVenda[0])) {
            /*{27}*/    $stLinha[] = substr(str_pad($this->cdsMovVenda[$this->contador]['CDLOJA'], 4, '0', STR_PAD_LEFT), 0, 4);
            /*{27}*/} else {
            /*{27}*/    $stLinha[] = substr(str_pad($this->cdsMovVenda['CDLOJA'], 4, '0', STR_PAD_LEFT), 0, 4);
            /*{27}*/}
            
            /*{28}*/$stLinha[] = '0';
            /*{29}*/$stLinha[] = '0000000';
            /*{30}*/$stLinha[] = '000000';
            /*{31}*/$stLinha[] = '00000000000000';
            /*{32}*/$stLinha[] = '0000';
            /*{33}*/$stLinha[] = '00000000000000000000';
            /*{34}*/$stLinha[] = '00000000000';
            /*{35}*/$stLinha[] = '00000000000';
            /*{36}*/$stLinha[] = '00000000000';
            /*{37}*/$stLinha[] = '000';
            /*{38}*/$stLinha[] = '0000';
            /*{39}*/$stLinha[] = '000000000000';
            /*{40}*/$stLinha[] = '0000000000';
            /*{41}*/$stLinha[] = '00000';
        
            $this->cdsARQUIVO[] = $stLinha;
            $this->arquivo[] = implode('', $stLinha);
        }
    }
    
    private function GravaDiferenca() {
        
        $this->cdsTotalVenda = $this->adqTotalVenda();
        
        if(isset($this->cdsMovVenda[0])) {
            $this->cdsCaixaControle = $this->adqCaixaControle($this->cdsMovVenda[$this->contador]['CDLOJA']);
        } else {
            $this->cdsCaixaControle = $this->adqCaixaControle($this->cdsMovVenda['CDLOJA']);
        }
        
        $this->cdsTotalSangria = $this->adqTotalSangria();
        
        //Se houve sobra/falta
        if(round($this->cdsTotalSangria['VRMOVIVEND'] - $this->cdsTotalVenda['VRTOTVEND'], 2) != 0) {
            if($this->cdsTotalSangria['VRMOVIVEND'] - $this->cdsTotalVenda['VRTOTVEND'] < 0) {
                $stTipoRece = '5599900311';//falta
            } else {
                $stTipoRece = '5599900309';// sobra
            }
        }
        
        $stValor = abs($this->cdsTotalSangria['VRMOVIVEND']);
        $stValor = explode('.', $stValor);
        $stValor[1] = str_pad($stValor[1], 4,'0', STR_PAD_RIGHT);
        $stValor[0] = str_pad($stValor[0], 9,'0', STR_PAD_LEFT);
        $stValor = $stValor[0].$stValor[1];
        
        $stTotalNota = $stValor;
        
        if(!empty($this->stTotalNotaDC) || $this->stTotalNotaDC == NULL) {
            $this->stTotalNotaDC = '';
        }
        
        $stSeqAux = substr(7500 + $this->stSeqOU, 0, 4);
        
        $this->stCampo09 = $this->stCampo09_DC;
        $this->stCampo09_DC = $this->stCampo09_DC + 1;
        $this->stCampo09_DC = str_pad($this->stCampo09_DC, 6,'0', STR_PAD_LEFT);
        
        $stLinha = '';
        
        /*{1}*/$stLinha[] = $this->CDEMPRESATG;
        
        /*{2}*/if(isset($this->cdsMovVenda[0])) {
        /*{2}*/    $stLinha[] = str_pad(substr($this->cdsMovVenda[$this->contador]['CDLOJA'], count($this->cdsMovVenda[$this->contador]['CDLOJA'])-4, 4), 4, '0', STR_PAD_LEFT);
        /*{2}*/} else {
        /*{2}*/    $stLinha[] = str_pad(substr($this->cdsMovVenda['CDLOJA'], count($this->cdsMovVenda['CDLOJA'])-4, 4), 4, '0', STR_PAD_LEFT);
        /*{2}*/}
        
        /*{3}*/$stLinha[] = $stSeqAux;
        /*{4}*/$stLinha[] = $this->ANO.$this->MES.$this->DIA;
        /*{5}*/$stLinha[] = substr($this->stCampoSomatorio_DC, 1, 10);
        /*{6}*/$stLinha[] = 'DC';
        /*{7}*/$stLinha[] = 'J';
        /*{8}*/$stLinha[] = str_pad(substr($this->cdsPesqFilial['NRINSJURFILI'], count($this->cdsPesqFilial['NRINSJURFILI'])-14, 14), 14, '0', STR_PAD_LEFT);
        /*{9}*/$stLinha[] = str_pad($this->stCampo09, 6, '0', STR_PAD_LEFT);
        /*{10}*/$stLinha[] = 'DC99';
        /*{11}*/$stLinha[] = $this->ANO.$this->MES.$this->DIA;
        /*{12}*/$stLinha[] = $this->ANO.$this->MES.$this->DIA;
        
        /*{13}*/if(isset($this->cdsMovVenda[0])) {
        /*{13}*/    $stLinha[] = substr(str_pad($this->cdsMovVenda[$this->contador]['CDLOJA'], 4, '0', STR_PAD_LEFT), 0, 4);
        /*{13}*/} else {
        /*{13}*/    $stLinha[] = substr(str_pad($this->cdsMovVenda['CDLOJA'], 4, '0', STR_PAD_LEFT), 0, 4);
        /*{13}*/}
        
        /*{15}*/$stLinha[] = '00000000000';
        /*{16}*/$stLinha[] = '00000000000';
        /*{17}*/$stLinha[] = '00000000000';
        /*{14}*/$stLinha[] = '00000000000';
        /*{18}*/$stLinha[] = '0000000000';
        /*{19}*/$stLinha[] = '0000000000';
        /*{20}*/$stLinha[] = '000000000000';
        /*{21}*/$stLinha[] = $stTipoRece;
        /*{22}*/$stLinha[] = '0000010000';
        /*{23}*/$stLinha[] = $stValor;
        /*{24}*/$stLinha[] = '0000000000000';
        /*{25}*/$stLinha[] = '0000000000000';
        /*{26}*/$stLinha[] = $stTotalNota;
        /*{27}*/$stLinha[] = '    ';
        /*{28}*/$stLinha[] = '0';
        /*{29}*/$stLinha[] = '0000000';
        /*{30}*/$stLinha[] = '000000';
        /*{31}*/$stLinha[] = '00000000000000';
        /*{32}*/$stLinha[] = '0000';
        /*{33}*/$stLinha[] = '00000000000000000000';
        /*{34}*/$stLinha[] = '00000000000';
        /*{35}*/$stLinha[] = '00000000000';
        /*{36}*/$stLinha[] = '00000000000';
        /*{37}*/$stLinha[] = '000';
        /*{38}*/$stLinha[] = '0000';
        /*{39}*/$stLinha[] = '000000000000';
        /*{40}*/$stLinha[] = '0000000000';
        /*{41}*/$stLinha[] = '00000';
        
        $this->cdsARQUIVO[] = $stLinha;
        $this->arquivo[] = implode('', $stLinha);
    }
    
    //QUERIES
    private function adqPesqFilial() {
        $params = array(
           ':NRORG'    => $this->NRORG,
           ':CDFILIAL' => $this->CDFILIAL
        );
        
        $resultadoService = $this->movimentoCaixaService->adqPesqFilial($params);
        return $resultadoService;
    }
    
    private function adqPesqRE() {
        
        $params = array(
           ':NRORG' => $this->NRORG,
           ':LOJAS' => $this->CDLOJA,
           ':MES'   => $this->MES,
           ':ANO'   => $this->ANO
        );
        
        $resultadoService = $this->movimentoCaixaService->adqPesqRE($params);
        return $resultadoService;
    }
    
    private function adqPesqDtMes() {
        $params = array(
           ':NRORG' => $this->NRORG,
           ':MES'   => $this->MES,
           ':ANO'   => $this->ANO
        );
        
        $resultadoService = $this->movimentoCaixaService->adqPesqDtMes($params);
        return $resultadoService;
    }
    
    private function adqExportacaoTG() {
        $params = array(
           ':NRORG'        => $this->NRORG,
           ':CDFILIAL'     => $this->CDFILIAL,
           ':CDFILIALTG'   => $this->CDLOJA,
           ':DTCONTABILTG' => $this->DATA
        );
        
        $resultadoService = $this->movimentoCaixaService->adqExportacaoTG($params);
        return $resultadoService;
    }
    
    private function acmDelEXPORTACAOTG(){
        $params = array(
           ':NRORG'        => $this->NRORG,
           ':CDFILIAL'     => $this->CDFILIAL,
           ':CDFILIALTG'   => $this->CDLOJA,
           ':DTCONTABILTG' => $this->DATA
        );
        
        $resultadoService = $this->movimentoCaixaService->acmDelEXPORTACAOTG($params);
        return $resultadoService;
    }
    
    private function adqMovVenda() {
        $params = array(
           ':NRORG'    => $this->NRORG,
           ':CDFILIAL' => $this->CDFILIAL,
           ':CDLOJA'   => $this->CDLOJA,
           ':DATA'     => $this->DATA
        );
        
        $resultadoService = $this->movimentoCaixaService->adqMovVenda($params);
        return $resultadoService;
    }
    
    private function adqVerificaRe() {
        $params = array(
           ':NRORG'      => $this->NRORG,
           ':CDCONTADOR' => $this->CDCONTADOR
        );

        $resultadoService = $this->movimentoCaixaService->adqVerificaRe($params);
        return $resultadoService;
    }
    
    private function acmInsereNovoCodigo() {
        $params = array(
           ':NRSEQUENCIAL' => $this->NRSEQUENCIAL,
           ':CDCONTADOR'   => $this->CDCONTADOR
        );
        
        $resultadoService = $this->movimentoCaixaService->acmInsereNovoCodigo($params);
        return $resultadoService;
    }
    
    private function adqSomatoria() {
        
        $params = array(
           ':NRORG'    => $this->NRORG,
           ':CDFILIAL' => $this->CDFILIAL,
           ':DATA'     => $this->DATA 
        );
        
        if(isset($this->cdsMovVenda[0])) {
            $params[':CDLOJA'] = $this->cdsMovVenda[$this->contador]['CDLOJA'];
        } else {
            $params[':CDLOJA'] = $this->cdsMovVenda['CDLOJA'];
        }
        
        $resultadoService = $this->movimentoCaixaService->adqSomatoria($params);
        return $resultadoService;
    }
    
    private function adqMovCaixaAux() {
        $params = array(
            ':NRORG'    => $this->NRORG,
            ':CDFILIAL' => $this->CDFILIAL,
            ':DATA'     => $this->DATA
        );
        
        if(isset($this->cdsMovVenda[0])) {
            $params[':CDLOJA'] = $this->cdsMovVenda[$this->contador]['CDLOJA'];
        } else {
            $params[':CDLOJA'] = $this->cdsMovVenda['CDLOJA'];
        }
        
        $resultadoService = $this->movimentoCaixaService->adqMovCaixaAux($params);
        return $resultadoService;
    }
    
    private function adqCaixaControle($lojaParam) {
        $params = array(
           ':NRORG'    => $this->NRORG,
           ':CDFILIAL' => $this->CDFILIAL,
           ':CDLOJA'   => $lojaParam
        );
        
        $resultadoService = $this->movimentoCaixaService->adqCaixaControle($params);
        return $resultadoService;
    }
    
    private function adqCaixas() {
        $params = array(
           ':NRORG'    => $this->NRORG,
           ':CDFILIAL' => $this->CDFILIAL,
           ':CDCAIXA'  => $this->CDCAIXA,
           ':CDLOJA'   => $this->CDLOJA
        );
        
        /////////////////teste
        $params[':CDLOJA'] = '03';
        /////////////////
        
        $resultadoService = $this->movimentoCaixaService->adqCaixas($params);
        return $resultadoService;
    }
    
    private function adqDN() {
        $params = array(
           ':NRORG'    => $this->NRORG,
           ':CDFILIAL' => $this->CDFILIAL,
           ':CDCAIXA'  => $this->stListaCaixaAux,
           ':DATA'     => $this->DATA
        );
        
        $resultadoService = $this->movimentoCaixaService->adqDN($params);
        return $resultadoService;
    }
    
    private function adqTotalVenda() {
        $params = array(
           ':NRORG'    => $this->NRORG,
           ':CDFILIAL' => $this->CDFILIAL,
           ':DATA'     => $this->DATA
        );
        
        if(!!$this->cdsMovVenda && isset($this->cdsMovVenda[0])) {
            $params[':CDLOJA'] = $this->cdsMovVenda[$this->contador]['CDLOJA'];
        } else {
            $params[':CDLOJA'] = $this->cdsMovVenda['CDLOJA'];
        }
        
        $resultadoService = $this->movimentoCaixaService->adqTotalVenda($params);
        return $resultadoService;
    }
    
    private function adqTotalSangria() {
        $params = array(
           ':NRORG'    => $this->NRORG,
           ':CDFILIAL' => $this->CDFILIAL,
           ':DATA'     => $this->DATA
        );

        if(isset($this->cdsMovVenda[0])) {
            $params[':CDLOJA'] = $this->cdsMovVenda[$this->contador]['CDLOJA'];
        } else {
            $params[':CDLOJA'] = $this->cdsMovVenda['CDLOJA'];
        }
        
        $resultadoService = $this->movimentoCaixaService->adqTotalSangria($params);
        return $resultadoService;
    }
    
    private function adqECF() {
        $params = array(
           ':NRORG'    => $this->NRORG,
           ':CDFILIAL' => $this->CDFILIAL,
           ':DATA'     => $this->DATA
        );
        
        if(isset($this->cdsMovVenda[0])) {
            $params[':CDCAIXA'] = $this->cdsMovVenda[$this->contador]['CDCAIXA'];
        } else {
            $params[':CDCAIXA'] = $this->cdsMovVenda['CDCAIXA'];
        }
        
        $resultadoService = $this->movimentoCaixaService->adqECF($params);
        return $resultadoService;
    }
    
    private function adqReducaoZ() {
        $params = array(
           ':NRORG'      => $this->NRORG,
           ':CDFILIAL'   => $this->CDFILIAL,
           ':NRECFREDZ'  => $this->cdsECF['NRECFTURCAIX'],
           ':DTREDUCAOZ' => $this->DATA
        );
        
        //teste
		$params[':NRECFREDZ'] = '001';
		//
        
        if(isset($this->cdsMovVenda[0])) {
            $params[':CDCAIXA'] = $this->cdsMovVenda[$this->contador]['CDCAIXA'];
        } else {
            $params[':CDCAIXA'] = $this->cdsMovVenda['CDCAIXA'];
        }
        
        $resultadoService = $this->movimentoCaixaService->adqReducaoZ($params);
        return $resultadoService;
    }
    
    private function adqTotalVendaVA() {
        $params = array(
           ':NRORG'    => $this->NRORG,
           ':CDFILIAL' => $this->CDFILIAL,
           ':DATA'     => $this->DATA
        );
        
        if(isset($this->cdsMovVenda[0])) {
            $params[':CDLOJA'] = $this->cdsMovVenda[$this->contador]['CDLOJA'];
            $params[':CDCAIXA'] = $this->cdsMovVenda[$this->contador]['CDCAIXA'];
        } else {
            $params[':CDLOJA'] = $this->cdsMovVenda['CDLOJA'];
            $params[':CDCAIXA'] = $this->cdsMovVenda['CDCAIXA'];
        }
        
        $resultadoService = $this->movimentoCaixaService->adqTotalVendaVA($params);
        return $resultadoService;
    }
    
    private function adqPARAVEND() {
        $params = array(
           ':NRORG'      => $this->NRORG,
           ':CDFILIAL'   => $this->CDFILIAL
        );
        
        $resultadoService = $this->movimentoCaixaService->adqPARAVEND($params);
        return $resultadoService;
    }
    
    private function adqMovCaixa() {
        $params = array(
           ':CDFILIAL'        => $this->CDFILIAL,
           ':DATA'            => $this->DATA
        );
            
        if(isset($this->cdsMovVenda[0])) {
            $params[':CDLOJA'] = $this->cdsMovVenda[$this->contador]['CDLOJA'];
            $params[':CDDOCTPRECETC'] = $this->cdsMovVenda[$this->contador]['CDDOCTPRECETC'];
                
            if($this->cdsMovVenda[$this->contador]['DOC'] == 'DC') {
                $params[':TCDPRODTPRECETC'] = 'T';
                $params[':CDPRODTPRECETC'] = '';
                $params[':TCDADMINCART'] = 'T';
                $params[':CDADMINCART'] = '';
            } else {
                $params[':TCDPRODTPRECETC'] = '';
                $params[':CDPRODTPRECETC'] = $this->cdsMovVenda[$this->contador]['CDPRODINTE'];
            
                if(empty($this->cdsMovVenda[$this->contador]['CDADMINCART']) || $this->cdsMovVenda[$this->contador]['CDADMINCART'] === null) {
                    $params[':TCDADMINCART'] = 'T';
                    $params[':CDADMINCART'] = '';
                } else{
                    $params[':TCDADMINCART'] = '';
                    $params[':CDADMINCART'] = $this->cdsMovVenda[$this->contador]['CDADMINCART'];
                }
            }
        } else {
            $params[':CDLOJA'] = $this->cdsMovVenda['CDLOJA'];
            $params[':CDDOCTPRECETC'] = $this->cdsMovVenda['CDDOCTPRECETC'];
                
            if($this->cdsMovVenda['DOC'] == 'DC') {
                $params[':TCDPRODTPRECETC'] = 'T';
                $params[':CDPRODTPRECETC'] = '';
                $params[':TCDADMINCART'] = 'T';
                $params[':CDADMINCART'] = '';
            } else {
                $params[':TCDPRODTPRECETC'] = '';
                $params[':CDPRODTPRECETC'] = $this->cdsMovVenda['CDPRODINTE'];
            
                if(empty($this->cdsMovVenda['CDADMINCART']) || $this->cdsMovVenda['CDADMINCART'] === null) {
                    $params[':TCDADMINCART'] = 'T';
                    $params[':CDADMINCART'] = '';
                } else{
                    $params[':TCDADMINCART'] = '';
                    $params[':CDADMINCART'] = $this->cdsMovVenda['CDADMINCART'];
                }
            }
        }
        
        $resultadoService = $this->movimentoCaixaService->adqMovCaixa($params);
        return $resultadoService;
    }
    
    private function adqContraValeDC() {
        $params = array(
           ':NRORG'      => $this->NRORG,
           ':CDFILIAL'   => $this->CDFILIAL,
           ':DATA'       => $this->DATA
        );
        
        if(isset($this->cdsMovVenda[0])) {
            $params[':CDLOJA'] = $this->cdsMovVenda[$this->contador]['CDLOJA'];
        } else {
            $params[':CDLOJA'] = $this->cdsMovVenda['CDLOJA'];
        }
        
        $resultadoService = $this->movimentoCaixaService->adqContraValeDC($params);
        return $resultadoService;
    }
    
    private function acmUpdTurcaixa() {
        $params = array(
           ':NRORG'      => $this->NRORG,
           ':CDFILIAL'   => $this->CDFILIAL,
           ':DATA'       => $this->DATA
        );
        
        $resultadoService = $this->movimentoCaixaService->acmUpdTurcaixa($params);
        return $resultadoService;
    }
    
    private function acmInsEXPORTACAOTG() {
        
        for($i = 0; $i < count($this->cdsARQUIVO); $i++) {
            $params = array(
                /*{1}*/':CDEMPRESATG'      => $this->cdsARQUIVO[$i][0],
            	/*{2}*/':CDFILIALTG'       => $this->cdsARQUIVO[$i][1],
            	/*{3}*/':NRNUMERORETG'     => $this->cdsARQUIVO[$i][2],
            	/*{5}*/':VRSOMNUMDCTG'     => (float)$this->cdsARQUIVO[$i][4],
            	/*{6}*/':CDTIPOOPERTG'     => $this->cdsARQUIVO[$i][5],
            	/*{7}*/':IDTPIJURNFTG'     => $this->cdsARQUIVO[$i][6],
            	/*{8}*/':NRINSJURNFTG'     => $this->cdsARQUIVO[$i][7],
            	/*{9}*/':NRNOTAFISCTG'     => $this->cdsARQUIVO[$i][8],
            	/*{10}*/':CDSERIEENTTG'     => $this->cdsARQUIVO[$i][9],
            	/*{13}*/':CDFILIRECETG'     => $this->cdsARQUIVO[$i][12],
            	/*{14}*/':VRDESPESATG'      => (float)$this->cdsARQUIVO[$i][13],
            	/*{15}*/':VRDESCONTOTG'     => (float)$this->cdsARQUIVO[$i][14],
            	/*{16}*/':VRICMSRETITG'     => (float)$this->cdsARQUIVO[$i][15],
            	/*{17}*/':VRIRRETIDOTG'     => (float)$this->cdsARQUIVO[$i][16],
            	/*{18}*/':NRINIMAQRETG'     => (float)$this->cdsARQUIVO[$i][17],
            	/*{19}*/':NRFIMMAQRETG'     => (float)$this->cdsARQUIVO[$i][18],
            	/*{20}*/':NRTOTMAQRETG'     => (float)$this->cdsARQUIVO[$i][19],
            	/*{21}*/':CDPRODUTOTG'      => $this->cdsARQUIVO[$i][20],
            	/*{22}*/':QTITEMPRODTG'     => (float)$this->cdsARQUIVO[$i][21],
            	/*{23}*/':VRUNITITEMTG'     => (float)$this->cdsARQUIVO[$i][22],
            	/*{24}*/':VRDESCITEMTG'     => (float)$this->cdsARQUIVO[$i][23],
            	/*{25}*/':VRIPIPRODTG'      => (float)$this->cdsARQUIVO[$i][24],
            	/*{26}*/':VRNOTAFISCTG'     => (float)$this->cdsARQUIVO[$i][25],
            	/*{27}*/':CDFILIEMITTG'     => $this->cdsARQUIVO[$i][26],
            	/*{28}*/':IDALTERADATG'     => $this->cdsARQUIVO[$i][27],
            	/*{29}*/':CDFIORIGDETG'     => $this->cdsARQUIVO[$i][28],
            	/*{30}*/':CDSERORIDETG'     => $this->cdsARQUIVO[$i][29],
            	/*{31}*/':NRIJURORIGDE'     => $this->cdsARQUIVO[$i][30],
            	/*{32}*/':CDCFISCOPTG'      => $this->cdsARQUIVO[$i][31],
            	/*{33}*/':NRLANBOLETTG'     => $this->cdsARQUIVO[$i][32],
            	/*{34}*/':VRDOTACAOTG'      => (float)$this->cdsARQUIVO[$i][33],
            	/*{35}*/':VRIMPINSSTG'      => (float)$this->cdsARQUIVO[$i][34],
            	/*{36}*/':VRIMPISSTG'       => (float)$this->cdsARQUIVO[$i][35],
            	/*{37}*/':NRMAQREGTG'       => $this->cdsARQUIVO[$i][36],
            	/*{38}*/':NRREDUCAOTG'      => $this->cdsARQUIVO[$i][37],
            	/*{39}*/':VLRMAQRETG'       => (float)$this->cdsARQUIVO[$i][38],
            	/*{40}*/':VLRCANCANTG'      => (float)$this->cdsARQUIVO[$i][39],
            	/*{41}*/':CROTG'            => $this->cdsARQUIVO[$i][40],
            	        ':IDTPEXPORTACAOTG' => 'TC'
            );
            
        /*{4}*/$auxData = $this->cdsARQUIVO[$i][3];
        /*{4}*/$auxANO = substr($auxData, 0, -4);
        /*{4}*/$auxMES = substr($auxData, -4, -2);
        /*{4}*/$auxDIA = substr($auxData, 6, 2);
        /*{4}*/$auxData = "$auxDIA-$auxMES-$auxANO";
        /*{4}*/$params[':DTCONTABILTG'] = $auxData;
            
        /*{11}*/$auxData = $this->cdsARQUIVO[$i][10];
        /*{11}*/$auxANO = substr($auxData, 0, -4);
        /*{11}*/$auxMES = substr($auxData, -4, -2);
        /*{11}*/$auxDIA = substr($auxData, 6, 2);
        /*{11}*/$auxData = "$auxDIA-$auxMES-$auxANO";
        /*{11}*/$params[':DTEMISSAOTG'] = $auxData;
            
        /*{12}*/$auxData = $this->cdsARQUIVO[$i][11];
        /*{12}*/$auxANO = substr($auxData, 0, -4);
        /*{12}*/$auxMES = substr($auxData, -4, -2);
        /*{12}*/$auxDIA = substr($auxData, 6, 2);
        /*{12}*/$auxData = "$auxDIA-$auxMES-$auxANO";
        /*{12}*/$params[':DTATVENPAGTG'] = $auxData;
            
            $resultadoService = $this->movimentoCaixaService->acmInsEXPORTACAOTG($params);
            return $resultadoService;
        }
        
    }
}
?>